<html>
<head>
   <link rel="stylesheet" type="text/css" href="gpgstyle.css" >
</head>
</body>
<div class=encryption>

<?php 

/*
-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

*/

 /************************************************************
 * Copyright Ralf Senderek, Ireland 2012. (http://senderek.ie)
 *
 * This file is part of the WEB ENCRYPTION EXTENSION (WEE)
 * File     : sendemail.php
 * Version  : 2.0.2
 * License  : GPL-v3
 * Signature: To protect the integrity of the source code, this program
 *            is signed with the code signing key used by the copyright
 *            holder, Ralf Senderek.
 * Date     : Friday, 11 Oct 2013
 * Contact  : Please send enquiries and bug-reports to opensource@senderek.ie
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *************************************************************/

 if (! is_file("gpgconfig.php")){

          die ("Config file does not exist.");
 }

 require_once('gpgconfig.php');

 if (isset($_REQUEST["email"])){
    $EMAIL = check_email($_REQUEST["email"]);
 }

 if (isset($_REQUEST["name"])){
    $NAME = htmlentities($_REQUEST["name"]);
 }

 if (isset($_REQUEST["message"])){
    $MESSAGE = htmlentities($_REQUEST["message"]);
 }
 if (isset($_REQUEST["slider"])){
    $SLIDERVALUE = $_REQUEST["slider"];
 }
 if (isset($_REQUEST["random"])){
    $RANDOM = $_REQUEST["random"];
 }


 if (! isset($ARCHIVE)) {
    $ARCHIVE = "no";
 }

 if (! isset($QUOTA)) {
    $QUOTA = 1;
 }

 if (! isset($SPAMCHECK)) {
    $SPAMCHECK = "no";
 }

 if (! isset($SLIDER)) {
    $SLIDER = "no";
 }

 if (! isset($SHOWCLEARTEXT)) {
    $SHOWCLEARTEXT = "no";
 }

 if (! isset($ALLOWATTACHMENTS)) {
    $ALLOWATTACHMENTS = "no";
 }

 function check_email($e) {
    $E = "";
    $ALLOWED = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789.@_-";
    for ($i=0; $i < strlen($e); $i++) {
         if (strpos($ALLOWED, $e[$i])) {
              $E = $E.$e[$i];
         }
    }
    return $E;
 }

 function send_alert($recipient, $subject, $alert) {
      mail($recipient,"ALERT [".$subject."]",$alert);
 }

 function is_valid($email) {
      if ((strlen($email) > 6) and (strlen($email) < 100)) {
           if (( substr_count($email, "@") == 1) and (substr_count($email, ".") > 0)){
                return true;
           }
      }
      return false;
 }

 function spamcheck() {
      global $MESSAGE;

      /* a message is considered spam if any of these conditions apply:
      empty message
      more than 4 links in a message
      less than 250 characters per link
      more than one slash per 50 characters
      any href in a message
      ALL SPAM WILL SIMPLY BE IGNORED.
      */

      $HTTP = substr_count(strtolower($MESSAGE), "http");
      $LEN = strlen($MESSAGE);
      $HREF = (int) substr_count(strtolower($MESSAGE),"href");
      $SLASH = (int) substr_count(strtolower($MESSAGE),"/");
      if (strlen($MESSAGE) == 0) { return false; }
      if ($HREF > 0) { return false; }
      if ($HTTP > 4) { return false; }
      if ($HTTP > 0){
          $LINKS = $LEN/$HTTP;
          if ($LINKS < 250) { return false; }
      }
      if ($SLASH > 0){
          $SL = $LEN/$SLASH;
          if ($SL < 50) { return false; }
      }
      return true;
 }

 function slidercheck() {
      global $SLIDERVALUE, $RANDOM;
      $MAXDIFF = 10;
      $DIFF = (int) $RANDOM - (int) $SLIDERVALUE;
      if (abs($DIFF) > $MAXDIFF) {
           return false;
      }
      return true;
 }


 function checks_ok() {
      global $SLIDER, $SPAMCHECK;
      if (($SLIDER == "yes") and ! slidercheck()) {
           return false;
      }
      if (($SPAMCHECK == "yes") and ! spamcheck()) {
           return false;
      }

      if (! isset($_REQUEST["send"])){
            return false;
      }
      // other checks here
      return true;
 }

 function print_success($name,$email,$message,$recipient) {
      echo "<blockquote>\n";
      echo "<h3>Thank you for contacting us.</h3>\n";
      echo "<p><b><i>Name: </i></b>".$name;
      echo "<p><b><i>Email: </i></b>".$email;
      echo "\n<p>We have received the following message:<p>";
      echo "\n<textarea cols=65 rows=15>\n";
      echo $message;
      echo "</textarea>\n";
      echo "<p>Your message has been sent to: <b>".$recipient."</b>\n";
      echo "<h3>We will reply to your email shortly.</h3>\n";
      echo "</blockquote>\n";
      echo "<p><center><input type=submit value='Close' onclick='javascript:history.back();' ></center>\n";
 }

 function store_message($name,$email,$message) {
      global $GPGDIR, $APACHE, $QUOTA, $RECIPIENT;
      $DIR = $GPGDIR."/messages";
      if (! is_dir($DIR)){
           echo "<p>run: mkdir $DIR";
           die ("<p><h3 class=error>Message directory $DIR does not exist.</h3>");
      }
      if (fileowner($DIR) != $APACHE){
           echo "<p>run: chown $APACHE $DIR";
           die("<p><h3 class=error>Directory $DIR is not owned by webserver user</h3>");
      }
      else{
           if (decbin(fileperms($DIR)) != "100000111000000" ) {
                echo "<p>run: chmod 700 $DIR";
                die  ("<p><h3 class=error>Directory $DIR has insecure permissions.</h3>");
           }
      }

      $USED = unix("du -s ".$DIR." | cut -f1  ");

      if (diskfreespace($DIR) < doubleval(0.2 * $QUOTA * 1048576)){
           // free disk space is less than 20 percent of quota.
           $M = "Your file system is going to fill up. There are only ".strval(diskfreespace($DIR))." bytes left.";
           send_alert($RECIPIENT, "free disk space is running out", $M);
      }

      if (doubleval($USED * 1024) > doubleval(0.8 * $QUOTA * 1048576) ) {
           // more than 80 percent of QUOTA has been used.
           $M = "Your stored messages are going to reach your quota. \nThere are currently ".strval($USED * 1024)." bytes stored. \nPlease delete unused messages to free disk space.";
           send_alert($RECIPIENT, "delete messages", $M);
      }
      else {
           // write message to disk
           $i = 0;
           $H = opendir($DIR);
           while (readdir($H)) {
                $i++;
           }
           $MSG = "Name: ".$name."\n";
           $MSG = $MSG."Email: ".$email."\n";
           $MSG = $MSG."Time: ".date("r")."\n\n";
           $MSG = $MSG.$message."\n\n";
           $FNAME = "message_".$i;
           $FILE = fopen($DIR."/".$FNAME,"w");
           fwrite($FILE,$MSG);
           fclose($FILE);
      }
 }

 function add_attachment($MSG,$B,$FN,$ATT){
           global $GPGDIR;

           $MARKER = "--".$B;
           $M = "Content-Type: text/plain; charset=\"iso-8859-1\" \nContent-Transfer-Encoding: 7bit\n\n";

           $M = $M.$MSG."\n".$MARKER."\n";
           $M = $M."Content-Type: application/pgp-encrypted \nContent-Transfer-Encoding: 7bit\nContent-Disposition: attachment; filename=\"".$FN.".asc\"\n\n";

           $handle = fopen($ATT, "r");
           $RESULT = fread($handle,20000000);
           fclose($handle);
           unix("rm ".$ATT);
           $M = $M."\n".$RESULT."\n";
           return $M;
 }


 if (isset($EMAIL) and is_valid($EMAIL) and checks_ok()){
     $HEADERS = "From: ".$EMAIL;
     if ($ALLOWATTACHMENTS == "yes"){
           // extend message with attachmentfile
           if (isset($_REQUEST['attachment']) and is_file($_REQUEST['attachment']) && isset($_REQUEST['attachmentfilename'])) {
                $MARK1 = "PHP-MIX-".md5(date('r', time())); ;
                $HEADERS = $HEADERS ."\r\nMIME-Version: 1.0\nContent-Type: multipart/mixed; boundary=\"".$MARK1."\";";
                $MESSAGE =  add_attachment($MESSAGE, $MARK1, $_REQUEST['attachmentfilename'], $_REQUEST['attachment'] );
                $MESSAGE = "--".$MARK1."\n".$MESSAGE."\n--".$MARK1."--\n";
           }
     }

     if ($ARCHIVE == "yes") {
          store_message($NAME, $EMAIL, $MESSAGE);
     }

     if (mail($RECIPIENT,"Direct Contact [".$EMAIL."]",$MESSAGE, $HEADERS)){
          if ($SHOWCLEARTEXT == "yes" ){
               $MESSAGE = $TEXT;
          }
          print_success($NAME, $EMAIL, $MESSAGE, $RECIPIENT);
     }
     else {
          echo "<h3 class=error>Sorry, we cannot send your email out.</h3>";
     }
 }
 else {
     if (checks_ok()) {
          echo "<h3 class=error>Please provide a valid email address.</h3>";
     }
 }


/*
-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.11 (GNU/Linux)

iQIcBAEBAgAGBQJSV4PdAAoJEPv24sKOnJjd/j8QAIn6LcvaBT3skuzOXjWcWQz/
7v5KqpFHGcClFcmZ+xUg202dM9Ussk8r7QFsVYwhYRjvuMnfjgJ0R3b1p9lAkEMg
W/GHAVQC7qbxdUDObpJkyXGbzM7TNHFh/9esUsNCM9z+YzIKjJO8/oa0UV3N+XQg
O8KBdaroqcx88gG5wIdeiR14KcIdCbBTUI4RWU9WZZNa6flPQrkwqCrsKSrbVysW
cna8qh8TvFhZ+pb04OCz+1b7cKPHbSK6Kt5izqtu/VSsIzHeoO53tmXZ7Xc3TBtC
VR/ynIMHZV7gQp7Qa87kUXyKDc7Gi3CdVz93UFO0aNgkm26+pPdvI7vL6xc9t6Un
5WbvIc0KVOBsWVtgPXwXYvuTFtABBvAuUaAzrENMFsZt7u0CMM/nRiJQ6tWlCn7a
EWq0fsjdxzcrP6i/cVvfERuN2p0FYzoeRgRRTrl46YbbSXD7T/HM8OE3SkI1HR4g
G1bG89Pco0I5u2ZftonSF1r3tdBcN4FsXgPgXgABRenimu7NDi9vMkgF4hr8m9v1
1uqHeg/Ia/gratzcT6uEeyX1sItreMcgo0Yb83dr7yDBYnBO0om2O+zKpkFtTxhv
jq3ZFFKjkFAnHVYNkfDooIyAim3yBSCB7AhF0XeUmQOmCus8AmynIiM+AtBFV7Me
g2RYcjnCZR97psphgAcl
=6dv0
-----END PGP SIGNATURE-----
*/?>
</div>
</body>
</html>
